unit test2Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  jkXML, StdCtrls, Mask, ToolEdit, ComCtrls, jktools;

type
  TForm1 = class(TForm)
    jkXML: TjkXML;
    Memo1: TMemo;
    Button1: TButton;
    TreeView1: TTreeView;
    TreeView2: TTreeView;
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    procedure Button1Click(Sender: TObject);
  private
    { Private-Deklarationen }
    procedure ShowXMLTree(nodes:TTreeNodes; node:TTreeNode; xmlNode: TjkXMLNode);
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;


implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var n:TTreeNode;
    t, t1:longint;
begin

  jkXML.filename:=edit1.text;
  t:=getTickCount;
  jkXML.ParseXMLFile;
  t1:=getTickCount;
  application.ProcessMessages;
  memo1.lines.AddStrings(jkXML.testOutput);
  application.ProcessMessages;
  memo1.lines.add('Zeit zum Einlesen der Datei:   '+inttostr(t1-t)+' ms');
  memo1.lines.add('Sparache:     '+jkXML.Language);
  memo1.lines.add('XML-version:  '+jkXML.XMLVersion);
  memo1.lines.add('standalone ?  '+BoolToStr(jkXML.Standalone));

{  memo1.lines.add(inttostr(jkXML.Prolog.ChildCount));
  memo1.lines.add(inttostr(jkXML.xml.ChildCount));}
  application.ProcessMessages;

  TreeView1.Items.Clear;
  application.ProcessMessages;
  TreeView2.Items.Clear;
  application.ProcessMessages;
  t:=getTickCount;
  ShowXMLTree(TreeView1.items, TreeView1.Items.Add(nil,'root'), jkxml.Prolog);
  t1:=getTickCount;
  memo1.lines.add('Zeit zum Fllen des 1. Baumes:   '+inttostr(t1-t)+' ms');
  application.ProcessMessages;
  t:=getTickCount;
  ShowXMLTree(TreeView2.items, TreeView2.Items.Add(nil,'root'), jkxml.XML);
  t1:=getTickCount;
  memo1.lines.add('Zeit zum Fllen des 2. Baumes:   '+inttostr(t1-t)+' ms');
  application.ProcessMessages;
  memo1.lines.add('');
end;

procedure TForm1.ShowXMLTree(nodes:TTreeNodes; node:TTreeNode; xmlNode: TjkXMLNode);
var i:longint;
    n:string;
begin
  //Comment, xmlPI, xmlDOCTYPE, xmlATTLIST, xmlELEMENT, xmlENTITY, xmlNameDecl, xmlCDATA
  if xmlNode.Nodetype=xmlTag then n:='TAG   ';
  if xmlNode.Nodetype=xmlData then n:='DATA   ';
  if xmlNode.Nodetype=xmlComment then n:='COMMENT   ';
  if xmlNode.Nodetype=xmlPI then n:='PI   ';
  if xmlNode.Nodetype=xmlDOCTYPE then n:='DOCTYPE   ';
  if xmlNode.Nodetype=xmlATTLIST then n:='ATTLIST   ';
  if xmlNode.Nodetype=xmlELEMENT then n:='ELEMENT   ';
  if xmlNode.Nodetype=xmlENTITY then n:='ENTITY   ';
  if xmlNode.Nodetype=xmlNOTATION then n:='NOTATION   ';
  if xmlNode.Nodetype=xmlNameDecl then n:='NameDECL   ';
  if xmlNode.Nodetype=xmlCDATA then n:='CDATA   ';
  if xmlNode.Nodetype=xmlroot then n:='ROOT   ';
  node.Text:=n+xmlNode.TagName+' / '+xmlNode.TagText+' / '+xmlNode.ParsedText;
  if xmlNode.childcount>0 then for i:=0 to xmlNode.ChildCount-1 do begin
    ShowXMLTree(nodes, nodes.AddChild(node,'added'), xmlNode.child[i]);
  end;
end;

end.
